import { ref as n, computed as x, watch as $, onMounted as z, onUnmounted as C, openBlock as u, createElementBlock as d, createElementVNode as E, Fragment as M, renderList as S, normalizeStyle as L, renderSlot as T } from "vue";
const b = {
  __name: "index",
  props: {
    items: {
      type: Array,
      required: !0,
      default: () => []
    },
    itemHeight: {
      type: Number,
      default: 50
    },
    // 是否立即执行加载方法，以防初始状态下内容无法撑满容器。
    scrollImmediate: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["onreachBottom"],
  setup(h, { emit: B }) {
    const e = h, I = B, o = n(null), i = n(null), f = n([]), v = n(0), g = n(0), k = x(() => o.value.offsetHeight), w = x(() => e.items.length * e.itemHeight);
    $(() => e.items, () => {
      a = !1, s();
    }, { deep: !0 });
    let a = !1, c = e.scrollImmediate;
    function s(r = !1) {
      const t = o.value.scrollTop, l = Math.floor(t / e.itemHeight), m = l + Math.ceil(k.value / e.itemHeight);
      v.value = Math.max(0, l), g.value = Math.min(m, e.items.length), f.value = e.items.slice(v.value, g.value), i.value.style.paddingTop = `${t}px`, i.value.style.height = `${w.value + e.itemHeight}px`;
      const H = i.value.scrollHeight, y = o.value.clientHeight;
      if (H - t - y >= 10)
        c = !0;
      else if (!r && !c) {
        c = !0;
        return;
      }
      H - t - y < 10 && !a && !r && (I("onreachBottom"), a = !0);
    }
    const p = () => {
      s();
    };
    return z(() => {
      s(!0), window.addEventListener("resize", p);
    }), C(() => {
      window.removeEventListener("resize", p);
    }), (r, t) => (u(), d("div", {
      ref_key: "scrollContainer",
      ref: o,
      class: "scroll-container",
      onScroll: t[0] || (t[0] = (l) => s(!1))
    }, [
      E("div", {
        ref_key: "itemsContainer",
        ref: i,
        class: "items-container"
      }, [
        (u(!0), d(M, null, S(f.value, (l, m) => (u(), d("div", {
          key: m,
          class: "item",
          style: L({ height: `${h.itemHeight}px` })
        }, [
          T(r.$slots, "default", { item: l })
        ], 4))), 128))
      ], 512)
    ], 544));
  }
};
export {
  b as default
};
